
Enumeration
  #WIN_MAIN
EndEnumeration

Enumeration
  #ST_SERVER
  #ST_PORT
  #ST_POPPORT 
  #ST_POPSERVER
  #ST_SENDER
  #ST_RPLTO
  #ST_SUBJECT  
  #ST_TO
  #ST_CC
  #ST_BCC  
  #ST_USERNAME
  #ST_PASSWORD 
  #ED_BODY  
  #ED_LOG
  #BTN_LOAD
  #BTN_SAVE
  #BTN_SEND  
  #BTN_DELETEFILE
  #BTN_ADDFILE      
  #T_SERVER
  #T_PORT
  #T_POPPORT
  #LV_ATTACHMENTS
  #Frame3D_0
  #PB
  #CMB_AUTHMODE
  #T_AUTHMODE
  #T_POPSERVER
  #T_ATTACHMENTS
  #T_MAILTO
  #T_PASSWORD
  #T_USERNAME
  #T_SENDER
  #T_RPLTO
  #T_CC
  #T_SUBJECT
  #T_BCC
  #T_BODY
  #T_LOG
EndEnumeration

Enumeration
  #SB
EndEnumeration

; taken from the Code-Archiv
Procedure.s Pref_ReadString(Abschnitt.s,Schluessel.s,file.s) 
 Value.s = Space(255) 
 Result.l = GetPrivateProfileString_ (Abschnitt, Schluessel, "", Value, Len(Value), @file.s) 
 Value.s = Left(Value.s, Result) 
 ProcedureReturn Value.s 
EndProcedure 

; taken from the Code-Archiv
Procedure Pref_WriteString(Abschnitt.s,Schluessel.s,Wert.s,file.s) 
 WritePrivateProfileString_ (Abschnitt, Schluessel, Wert,@file.s) 
EndProcedure 

Procedure.l GetBase64Size(file.s)
If ReadFile(0,file.s) 
   bytes.l=Lof()    
   If bytes%3>0
      bytes=(bytes/3+1)*3
   EndIf
   bytes=4*bytes/3-1
EndIf
ProcedureReturn bytes.l
EndProcedure

Procedure DisableAuthgadgets()
 If GetGadgetState(#CMB_AUTHMODE)=0
   status.l=1
 EndIf   
 DisableGadget(#ST_POPSERVER,Status.l)
 DisableGadget(#ST_POPPORT,Status.l)
 DisableGadget(#ST_PASSWORD,Status.l)
 DisableGadget(#ST_USERNAME,Status.l)
EndProcedure

Procedure ReadDefaultValues(file.s)
SetGadgetState(#CMB_AUTHMODE,Val(Pref_ReadString("SMTP","AUTHMODE",file.s)))
SetGadgetText(#ST_SERVER    ,Pref_ReadString("SMTP","Server",file.s))
SetGadgetText(#ST_PORT      ,Pref_ReadString("SMTP","Port",file.s))
SetGadgetText(#ST_POPSERVER ,Pref_ReadString("SMTP","PopServer",file.s))
SetGadgetText(#ST_POPPORT   ,Pref_ReadString("SMTP","PopPort",file.s))
SetGadgetText(#ST_USERNAME  ,Pref_ReadString("SMTP","Username",file.s))
SetGadgetText(#ST_PASSWORD  ,Pref_ReadString("SMTP","Password",file.s))
SetGadgetText(#ST_RPLTO     ,Pref_ReadString("SMTP","RplTo",file.s))
SetGadgetText(#ST_SENDER    ,Pref_ReadString("SMTP","Sender",file.s))
SetGadgetText(#ST_TO        ,Pref_ReadString("SMTP","To",file.s))
SetGadgetText(#ST_BCC       ,Pref_ReadString("SMTP","BCC",file.s))
SetGadgetText(#ST_CC        ,Pref_ReadString("SMTP","CC",file.s))
DisableAuthGadgets()
EndProcedure

Procedure WriteDefaultValues(file.s)
Pref_WriteString("SMTP","AUTHMODE" ,Str(GetGadgetState(#CMB_AUTHMODE)),file.s)
Pref_WriteString("SMTP","Server"   ,GetGadgetText(#ST_SERVER),file.s)
Pref_WriteString("SMTP","Port"     ,GetGadgetText(#ST_PORT),file.s)
Pref_WriteString("SMTP","PopServer",GetGadgetText(#ST_POPSERVER),file.s)
Pref_WriteString("SMTP","PopPort"  ,GetGadgetText(#ST_POPPORT),file.s)
Pref_WriteString("SMTP","Username" ,GetGadgetText(#ST_USERNAME),file.s)
Pref_WriteString("SMTP","Password" ,GetGadgetText(#ST_PASSWORD),file.s)
Pref_WriteString("SMTP","Sender"   ,GetGadgetText(#ST_SENDER),file.s)
Pref_WriteString("SMTP","RplTo"    ,GetGadgetText(#ST_RPLTO),file.s)
Pref_WriteString("SMTP","To"       ,GetGadgetText(#ST_TO),file.s)
Pref_WriteString("SMTP","CC"       ,GetGadgetText(#ST_CC),file.s)
Pref_WriteString("SMTP","BCC"      ,GetGadgetText(#ST_BCC),file.s)
Pref_WriteString("PROG","WIDTH"    ,Str(WindowWidth()),file.s)
EndProcedure

Procedure ClearStatusBar()
For i=0 To 3
    StatusBarText(#SB,i,"")
Next
EndProcedure

Procedure SetProgressbarRange(Gadget.l, Minimum.l, Maximum.l)  ; by V2 - from Code Archiv
  ;? SetProgressbarRange(#progressbar, 0, 100)
  PBM_SETRANGE32 = $400 + 6
  SendMessage_(GadgetID(Gadget), PBM_SETRANGE32, Minimum, Maximum)
EndProcedure



Procedure.l OpenWin()
  mainHwnd.l=OpenWindow(#WIN_MAIN, 216, 0, 800, 554,  #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered, "SMTP Auth")
  If mainHwnd.l
    If CreateStatusBar(#SB, mainHwnd)
       AddStatusBarField(60)
       AddStatusBarField(80)
       AddStatusBarField(50)
       AddStatusBarField(410)
    EndIf
    If CreateGadgetList(mainHwnd)
      TextGadget(#T_SERVER, 38, 24, 70, 20, "SMTP-Server:")
      StringGadget(#ST_SERVER, 110, 20, 280, 20, "")
      
      TextGadget(#T_PORT, 435, 24, 23, 20, "Port:")      
      StringGadget(#ST_PORT, 460, 20, 30, 20, "25")
      
      TextGadget(#T_POPSERVER, 47, 47, 59, 16, "Pop3Server:")
      StringGadget(#ST_POPSERVER, 110, 45, 280, 20, "")
      
      TextGadget(#T_POPPORT, 435, 47, 23, 20, "Port:")      
      StringGadget(#ST_POPPORT, 460, 45, 30, 20, "110")
                 
      TextGadget(#T_AUTHMODE, 50, 72, 56, 20, "Auth Mode:")
      ComboBoxGadget(#CMB_AUTHMODE, 110, 70, 120, 20)
      
      AddGadgetItem(#CMB_AUTHMODE,-1,"NONE")
      AddGadgetItem(#CMB_AUTHMODE,-1,"SMTP AUTH")
      AddGadgetItem(#CMB_AUTHMODE,-1,"POP Before SMTP")      
      TextGadget(#T_USERNAME, 237, 72, 53, 14, "Username:")
      StringGadget(#ST_USERNAME, 290, 70, 100, 20, "")      
      TextGadget(#T_PASSWORD, 407, 72, 50, 20, "Password:")
      StringGadget(#ST_PASSWORD, 460, 70, 100, 20, "",#PB_String_Password)
      
      TextGadget(#T_SENDER, 55, 97, 47, 14, "Sender:")     
      StringGadget(#ST_SENDER, 110, 95, 280, 20, "")    
      
      ButtonGadget(#BTN_SAVE, 460, 95, 70, 20, "Save")
      
      TextGadget(#T_RPLTO, 55, 122, 47, 14, "Reply To:")     
      StringGadget(#ST_RPLTO, 110, 120, 280, 20, "")
      
      ButtonGadget(#BTN_LOAD, 460, 120, 70, 20, "Load")
      
      TextGadget(#T_MAILTO, 20, 170, 41, 15, "Mail To:")
      StringGadget(#ST_TO, 60, 166, 340, 20, "")
      TextGadget(#T_CC, 41, 196, 19, 15, "CC:")      
      StringGadget(#ST_CC, 60, 191, 340, 20, "")
      TextGadget(#T_BCC, 35, 222, 26, 13, "BCC:")      
      StringGadget(#ST_BCC, 60, 218, 340, 20, "")
      TextGadget(#T_SUBJECT, 20, 250, 42, 14, "Subject:")
      StringGadget(#ST_SUBJECT, 60, 248, 370, 20, "")                  
      TextGadget(#T_BODY, 30, 273, 29, 15, "Body:")                  
      EditorGadget(#ED_BODY, 60, 272, 370, 202)
      TextGadget(#T_ATTACHMENTS, 446, 257, 62, 13, "Attachments")      
      ButtonGadget(#BTN_DELETEFILE, 534, 250, 20, 20, "-")
      ButtonGadget(#BTN_ADDFILE, 556, 250, 20, 20, "+")                             
      ListViewGadget(#LV_ATTACHMENTS, 440, 273, 140, 200)
      
      ProgressBarGadget(#PB, 60, 480,370, 20, 0,100)
      
      ButtonGadget(#BTN_SEND, 510, 480, 70, 20, "Send")
      Frame3DGadget(#Frame3D_0, 10, 150, 580, 360, "Mail")
      TextGadget(#T_LOG, 600, 10, 60, 13, "Log")
      EditorGadget(#ED_LOG, 600,30,195,490)
    EndIf
  EndIf
  ProcedureReturn mainHwnd.l
EndProcedure




; ExecutableFormat=
; EOF